<?php
/* $Id: install.php 140 2011-03-19 00:25:32Z mir $ */

if (version_compare(PHP_VERSION, '5.1.3') === -1) {
    die("PHP >= 5.1.3 is required to run this application");
}

error_reporting(E_ALL);
ini_set('display_errors', 0);

session_start();

$root = getcwd();
chdir('..');
$top = getcwd();
chdir($root);

ini_set('include_path', "$top:$top/navigate:$top/utils:$top/include:$top/caldav:$top/caldav/awl:$top/templates:$top/events");

include_once "$top/utils/timezone.php";
include_once "$top/utils/helper.php";

$db_drivers = array('sqlite','pgsql');

/* Test for an existing config.inc.php */
function remove_config() {
    if (file_exists("../config.inc.php")) {
        $postfix = date("c");
        copy("../config.inc.php", "../$postfix-config.inc.php");
        unlink("../config.inc.php");
    }
}

$config_inc = <<<_CONFIG
    /*******************************************************************
     * Change only below this line.
     * But in generel you should not changes these settings
     * except via the setup script.
     ******************************************************************/

    define('TITLE', __TITLE__);
    define('TIMEZONE', __TIMEZONE__);
    define('ERROR_DISPLAY', __ERROR_DISPLAY__);
    define('ERROR_LOG', __ERROR_LOG__);
    define('LOG_FILE', __LOG_FILE__);
    define('TOP_FOLDER', __TOP_FOLDER__);
    /* / at the end of WEB_ROOT is mandatory */
    define('WEB_ROOT', __WEB_ROOT__);
    define('DBDRIVER', __DBDRIVER__);
    define('DNS', __DNS__);
    define('ADMIN_MAIL', __ADMIN_MAIL__);

    /* Settings which can be change by individual users.
     * Settings are change in config from the menu
     */
    define('VIEW_STYLE', __VIEW_STYLE__);
    define('TIMEOUT', __TIMEOUT__);
    define('WEEK_START_SUNDAY', __WEEK_START_SUNDAY__);
    define('START_HOUR', __START_HOUR__);
    define('END_HOUR', __END_HOUR__);

    /*******************************************************************
     * Do not change below this line
     * All changes should be done above
     ******************************************************************/

    require_once 'include/user_settings.inc.php';
    require_once 'utils/authenticate.php';
    require_once 'utils/helper.php';

    session_cache_limiter('private');
    if (isset(\$_COOKIE['WEBCAL_EXPIRE'])) {
        \$expire = \$_COOKIE['WEBCAL_EXPIRE'];
        session_cache_expire(\$expire);
        unset(\$_COOKIE['WEBCAL_EXPIRE']);
        setcookie('WEBCAL_EXPIRE', FALSE);
    }
    else
        session_cache_expire(TIMEOUT);
    session_start();
    \$_SESSION['WEB_ROOT'] = WEB_ROOT;

    error_reporting(E_ALL ^ E_NOTICE ^ E_USER_NOTICE);

    if (isset(\$_SESSION['user_settings'])) {
        ini_set('date.timezone', \$_SESSION['user_settings']->getTimezone());
    }
    else if (defined('TIMEZONE')) {
        ini_set('date.timezone', TIMEZONE);
    }
    else {
        ini_set('date.timezone', 'Etc/UTC');
    }

    if (defined('ERROR_DISPLAY')) {
        if (ERROR_DISPLAY) {
            ini_set('display_errors', 'on');
        }
        else {
            ini_set('display_errors', 'off');
        }
    }
    if (defined('ERROR_LOG') && ERROR_LOG) {
        ini_set('log_errors', 'on');
        ini_set('error_log', LOG_FILE);
    }

    if (! isset(\$_SESSION['isTimeout'])) {
    	if (isset(\$_SESSION['user_settings']))
        	\$_SESSION['user_settings']->isTimeout();
    }
    else
	unset(\$_SESSION['isTimeout']);
_CONFIG;

$config_apache = <<<_CONFIG
    Alias __ALIAS__ "__TOP__"
    <Directory "__TOP__">
        Options Multiviews SymLinksIfOwnerMatch
        php_value include_path '.:__TOP__:__TOP__navigate:__TOP__utils:__TOP__include:__TOP__caldav:__TOP__caldav/awl:__TOP__templates:__TOP__events'
    </Directory>
_CONFIG;

$htaccess = <<<_HTACCESS
        Options None
        Order deny,allow
        Deny from all
        Allow from 127.0.0.1/32 ::1/128
_HTACCESS;

$head = <<<_HEAD
<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<title>Web Calendar Installation</title>
<meta name="generator" content="Bluefish 1.0.7"/>
<meta name="author" content="Michael Rasmussen"/>
<meta name="date" content="2009-03-23T20:45:48+0100"/>
<meta name="copyright" content="© 2007, Michael Rasmussen. Licensed under GPL"/>
<meta name="keywords" content=""/>
<meta name="description" content=""/>
<meta name="ROBOTS" content="NOINDEX, NOFOLLOW"/>
<meta http-equiv="content-type" content="application/xhtml+xml; charset=UTF-8"/>
<meta http-equiv="content-style-type" content="text/css"/>
<meta http-equiv="expires" content="-1"/>
<meta http-equiv="Pragma" content="no-cache"/>
<link rel="stylesheet" type="text/css" href="../css/top_level.css" />
<link rel="shortcut icon" href="../pixmaps/favicon.ico" />
</head>
<body>
<table style="width: 100%;">
<tr>
<td style="width: 33%"><img src="../pixmaps/calendar.png" alt="calendar.png" /></td>
<td style="width: 33%; text-align: center;"><img style="border: 0" src="../pixmaps/stock_init.png" width="48" height="48" alt="Setup"/></td>
<td style="text-align: right"><span style="font-size: 1.6em">DAViCal Web Calendar</span><br/> - A Web Interface for <a href="javascript: newwin('http://rscds.sourceforge.net/');">DAViCal</a></td>
</tr>
</table>
_HEAD;

$foot = <<<_FOOTER
<div id="footer">
<p>
    <a href="http://validator.w3.org/check?uri=referer">
        <img src="http://www.w3.org/Icons/valid-xhtml10-blue.png"
        alt="Valid XHTML 1.0 Strict" height="31" width="88" />
    </a>
    <a href="http://jigsaw.w3.org/css-validator/check/referer">
        <img src="http://www.w3.org/Icons/valid-css2-blue.png"
        alt="Valid CSS 2.0" height="31" width="88" />
    </a>
</p>
</div>
</body>
</html>
_FOOTER;

function shutdown() {
    global $head, $foot;

    $isError = false;
    if ($error = error_get_last()) {
        switch($error['type']) {
            case E_ERROR:
            case E_CORE_ERROR:
            case E_COMPILE_ERROR:
            case E_USER_ERROR:
                $isError = true;
                break;
        }
    }

    if ($isError) {
        print $head;
        print '<div id=\"ui\">';
        if ($error['message'] == "Class 'PDO' not found") {
            echo '<p style="text-align: center; font-size: 1.5em">
                This install cannot continue because the module PDO is not installed</p>';
        }
        else
            echo "<p style=\"text-align: center; font-size: 1.5em\">Script execution halted ({$error['message']})</p>";
        print '</div>';
        print $foot;
    }
    remove_config();
}

register_shutdown_function('shutdown');

function get_server_timezone() {
    $tz_abbr = date('T');
    return timezone_name_from_abbr($tz_abbr);
}

function stage_1() {
    switch ($_POST['driver']) {
        case 'sqlite':
            $dns = <<<_DNS
            <tr>
                <td class="config">Database file</td>
                <td class="config">
                    <input type="text" name="dns"/>
                    <input type="hidden" name="driver" value="{$_POST['driver']}"/>
                </td>
            </tr>
_DNS;
            break;
        case 'pgsql':
            $dns = <<<_DNS
            <tr>
                <td class="config" colspan="3">
                    Below you will find reasonable default values for most.<br/>
                    <span style="font-weight: bold">database name</span>: Name of an exiting database used as template<br/>
                    on Postgresql this database is normally named template1<br/>
                    You should normally not need any other information than the following:<br/>
                    <span style="font-weight: bold">postgresql dba</span>: An existing postgresql user with permission to create<br/>
                    new databases and users.<br/>
                    <span style="font-weight: bold">postgresql dba password</span>: Password for this user<br/>
                    <span style="font-weight: bold">Password for webcal admin</span>: Password for the webcal admin user<br/>
                </td>
            </tr>
            <tr>
                <td class="config">host</td>
                <td class="config">
                    <input type="text" name="dns[]" value="localhost"/>
                </td>
            </tr>
            <tr>
                <td class="config">port</td>
                <td class="config">
                    <input type="text" name="dns[]" value="5432"/>
                </td>
            </tr>
            <tr>
                <td class="config">database name</td>
                <td class="config">
                    <input type="text" name="dns[]" value="template1"/>
                </td>
            </tr>
            <tr>
                <td class="config">postgresql dba</td>
                <td class="config">
                    <input type="text" name="dns[]" value="root"/>
                </td>
            </tr>
            <tr>
                <td class="config">postgresql dba password</td>
                <td class="config">
                    <input type="password" name="dns[]" value="password"/>
                    <input type="hidden" name="driver" value="{$_POST['driver']}"/>
                </td>
            </tr>
_DNS;
            break;
    }
    return <<<__FORM
    <h1 style="text-align: center">Setup: Stage 1/4</h1>
    <form action="{$_SERVER['PHP_SELF']}" method="post">
        <table class="config">
            $dns
            <tr>
                <td class="config">Password for webcal admin</td>
                <td class="config"><input name="pwd1" type="password"/></td>
            </tr>
            <tr>
                <td class="config">Repeat Password</td>
                <td class="config"><input name="pwd2" type="password"/></td>
            </tr>
            <tr>
                <td class="config" colspan="2" style="text-align: center">
                    <input type="hidden" name="stage" value="2"/>
                    <input type="submit" name="action" value=">> Next"/>
                </td>
            </tr>
        </table>
    </form>
__FORM;
}

function stage_2($top, $root) {
    include_once "$top/utils/persistens.php";
    global $timezones, $VERSION;
    $dns = '';
    $tz = '';

    try {
        if ($_POST['pwd1'] != $_POST['pwd2'])
            throw new Exception("Password does not compare");
        if ($_POST['driver'] == 'sqlite') {
            $dns = $_POST['dns'];
            $db = Persistens::getInstance($_POST['driver'], "$top/$dns");
            $name = NULL;
            $pwd = NULL;
        }
        else {
            $dns = "host={$_POST['dns'][0]} port={$_POST['dns'][1]} dbname={$_POST['dns'][2]} user={$_POST['dns'][3]} password={$_POST['dns'][4]}";
            $db = Persistens::getInstance($_POST['driver'], $dns);
            $name = "webcal";
            $user = "webcal";
            $pwd = $_POST['pwd1'];
            $db->initDatabase($name, $pwd);
            $db = NULL;
            $dns = "host={$_POST['dns'][0]} port={$_POST['dns'][1]} dbname=$name user=$user password=$pwd";
            $db = Persistens::getInstance($_POST['driver'], $dns);
            //throw new Exception(var_export($dns, true));
        }
        $db->createDatabase($name);
        $db->execute("insert into about (version) values ('$VERSION')");
        $data['uid'] = 'admin';
        $data['pwd'] = sha1($_POST['pwd1']);
        $data['timezone'] = get_server_timezone();
        $data['userrole'] = 0;
        $data['seckey'] = '';
        $data['pubkey'] = '';
        $data['timeout'] = 15 * 60;
        $data['view'] = 'week';
        $data['week_start'] = false;
        $data['start'] = 8;
        $data['end'] = 17;
        $db->newUser($data);
    }
    catch (Exception $ex) {
        remove_config();
        $result = "<p style=\"text-align: center\">stage2: {$ex->getMessage()}</p>";
        $result .= "<p style=\"text-align: center\">
            <input type=\"button\" value=\"Back\"
             onclick=\"javascript: history.back()\"/></p>";
        return $result;
    }
    $config['DBDRIVER'] = $_POST['driver'];
    $config['DNS'] = $dns;
    $_SESSION['config'] = $config;
    foreach ($timezones as $timezone) {
        $tz .= "<option value=\"$timezone\"";
        if ($timezone == get_server_timezone())
            $tz .= ' selected="true"';
        $tz .= ">$timezone</option>";
    }
    return <<<__FORM
    <h1 style="text-align: center">Setup: Stage 2/4</h1>
    <form action="{$_SERVER['PHP_SELF']}" method="post">
        <table class="config">
            <tr>
                <td class="config">Application web root</td>
                <td class="config"><input name="web_root" type="text"/></td>
            </tr>
            <tr>
                <td class="config">Application title</td>
                <td class="config"><input name="title" type="text"/></td>
            </tr>
            <tr>
                <td class="config">Server timezone</td>
                <td class="config"><select name="timezone">$tz</select></td>
            </tr>
            <tr>
                <td class="config">Display errors in browser</td>
                <td class="config">
                    <select name="display_error">
                        <option value="no">No</option>
                        <option value="yes">Yes</option>
                    </select>
                </td>
            </tr>
            <tr>
                <td class="config">Log errors</td>
                <td class="config">
                    <select name="log_error">
                        <option value="no">No</option>
                        <option value="yes">Yes</option>
                    </select>
                </td>
            </tr>
            <tr>
                <td class="config">Log file</td>
                <td class="config"><input name="log_file" type="text"/></td>
            </tr>
            <tr>
                <td class="config">Administrator email</td>
                <td class="config"><input name="admin_email" type="text"/></td>
            </tr>
            <tr>
                <td class="config" colspan="2" style="text-align: center">
                    <input type="hidden" name="stage" value="3"/>
                    <input type="submit" name="action" value=">> Next"/>
                </td>
            </tr>
        </table>
    </form>
__FORM;
}

function stage_3($top, $root) {
    $config = $_SESSION['config'];
    $config['WEB_ROOT'] = $_POST['web_root'];
    $config['TITLE'] = $_POST['title'];
    $config['TIMEZONE'] = $_POST['timezone'];
    $config['ERROR_DISPLAY'] = ($_POST['display_error'] == 'yes')? 'TRUE' : 'FALSE';
    $config['ERROR_LOG'] = ($_POST['log_error'] == 'yes')? 'TRUE' : 'FALSE';
    $config['LOG_FILE'] = $_POST['log_file'];
    $config['ADMIN_MAIL'] = $_POST['admin_email'];
    $_SESSION['config'] = $config;
    return <<<__FORM
    <h1 style="text-align: center">Setup: Stage 3/4</h1>
    <form action="{$_SERVER['PHP_SELF']}" method="post">
        <table class="config">
            <tr>
                <td class="config">Default view</td>
                <td class="config">
                    <select name="view_style">
                        <option value="day">Day</option>
                        <option value="week" selected="true">Week</option>
                        <option value="month">Month</option>
                    </select>
                </td>
            </tr>
            <tr>
                <td class="config">Default session timeout in minuts</td>
                <td class="config"><input name="timeout" type="text" value="60"/></td>
            </tr>
            <tr>
                <td class="config">Default start of week Sunday</td>
                <td class="config">
                    <select name="week_start_sunday">
                        <option value="no" selected="true">No</option>
                        <option value="yes">Yes</option>
                    </select>
                </td>
            </tr>
            <tr>
                <td class="config">Default day start</td>
                <td class="config"><input name="start_day" type="text" value="8"/></td>
            </tr>
            <tr>
                <td class="config">Default day end</td>
                <td class="config"><input name="end_day" type="text" value="17"/></td>
            </tr>
            <tr>
                <td class="config" colspan="2" style="text-align: center">
                    <input type="hidden" name="stage" value="4"/>
                    <input type="submit" name="action" value=">> Next"/>
                </td>
            </tr>
        </table>
    </form>
__FORM;
}

function stage_4($top, $root) {
    include_once "$top/utils/persistens.php";
    global $config_inc, $config_apache, $htaccess;

    $config = $_SESSION['config'];
    $config['VIEW_STYLE'] = $_POST['view_style'];
    $config['TIMEOUT'] = $_POST['timeout'] * 60;
    $config['WEEK_START_SUNDAY'] =
        ($_POST['week_start_sunday'] == 'yes')? 'TRUE' : 'FALSE';
    $config['START_HOUR'] = $_POST['start_day'];
    $config['END_HOUR'] = $_POST['end_day'];
    $config['TOP_FOLDER'] = $top;
    $start = strpos($config['WEB_ROOT'], "/");
    if ($start != 0 || $start === FALSE)
        $config['WEB_ROOT'] = '/'.$config['WEB_ROOT'];
    $end = strrpos($config['WEB_ROOT'], "/");
    if ($end != strlen($config['WEB_ROOT']) - 1 || $end == FALSE)
        $config['WEB_ROOT'] = $config['WEB_ROOT'].'/';
    foreach ($config as $key => $value) {
        if ($value !== 'TRUE' && $value !== 'FALSE')
            $value = "'$value'";
        $config_inc = str_replace('__'.$key.'__', $value, $config_inc);
    }
    // Create config.inc.php
    $file = "<?php\n" . $config_inc . "\n?>\n";
    file_put_contents("$top/config.inc.php", $file);
    // Create .htaccess in install
    if (! file_exists("$root/.htaccess"))
        file_put_contents("$root/.htaccess", $htaccess);
    // Create webcal in conf.d
    $root = $config['WEB_ROOT'];
    $root = substr($root, 0, -1);
    $config_apache = str_replace('__ALIAS__', $root, $config_apache);
    $config_apache =
        str_replace('__TOP__', $config['TOP_FOLDER'].'/', $config_apache);
    $result = '<p style="text-align: center">If you haven\'t done basic setup
        by executing the setup script you must Copy/paste the following
        to /etc/[apache config]/conf.d/webcal.conf and restart apache<br/>';
    $result .= '<textarea rows="10" cols="60">';
    $result .= htmlspecialchars($config_apache);
    $result .= '</textarea></p>';
    $result .= '<p style="text-align: center">After restart of
        apache follow this link to webcal';
    /*$protocol = (empty($_SERVER['HTTPS']) ||
			strcasecmp("off", $_SERVER['HTTPS']) == 0) ? "http" : "https";
    $server = ($_SERVER['SERVER_PORT'] != 80 || $_SERVER['SERVER_PORT'] != 443)?
        $_SERVER['SERVER_NAME'].':'.$_SERVER['SERVER_PORT'] : $_SERVER['SERVER_NAME'];
    $url = "$protocol://$server$root";
    $webroot = ($config['WEB_ROOT'][strlen($config['WEB_ROOT']) - 1] == '/') ?
        $config['WEB_ROOT']."install</p>" : $config['WEB_ROOT']."/install</p>";*/
    $url = getServerUrl($config['WEB_ROOT']);
    $webroot = getServerUrl($config['WEB_ROOT'], $root);
    $result .= " <a href=\"$url\">webcal</a></p>";
    $result .= '<p style="text-align: center">Remember to disable ' .
        'write access to ' . "$top/install";
    // update database
    if ($config['DBDRIVER'] == 'sqlite') {
        $db = Persistens::getInstance($config['DBDRIVER'], $top."/".$config['DNS']);
    }
    else {
        $db = Persistens::getInstance($config['DBDRIVER'], $config['DNS']);
    }
    $db->changeDefault($config);
    $_SESSION = array();
    if (isset($_COOKIE[session_name()])) {
        setcookie(session_name(), '', time()-42000, '/');
    }
    session_destroy();
    return $result;
}

if (count($_POST) > 0) {
    if (isset($_POST['stage'])) {
        switch ($_POST['stage']) {
            case '1': $page = stage_1(); break;
            case '2': $page = stage_2($top, $root); break;
            case '3': $page = stage_3($top, $root); break;
            case '4': $page = stage_4($top, $root); break;
            case '5': $page = stage_4($top, $root); break;
            default: trigger_error("Unknown stage", E_USER_ERROR);
        }
    }
    else {
        remove_config();
        trigger_error("Unknown stage", E_USER_ERROR);
    }
}
else {
    remove_config();

    $error = FALSE;
    $page = '<h1 style="text-align: center">Setup: Stage 0/4</h1>';
    $page .= '<table class="config">';
    $page .= '<tr><td>Checking if module mcrypt is available</td>';
    try {
        $mcrypt = MCRYPT_ENCRYPT;
        if (is_integer($mcrypt)) {
            $page .= '<td><span style="font-size: 1.2em; font-weight: bold;
             background: green">OK</span></td></tr>';
        }
        else {
            $page .= '<td><span style="font-size: 1.2em; font-weight: bold;
             background: red">NO</span></td></tr>';
            $error = TRUE;
        }
    } catch (ErrorException $ex) {
        $page .= '<td><span style="font-size: 1.2em; font-weight: bold;
         background: red">NO</span></td></tr>';
        $error = TRUE;
    }
    $page .= '<tr><td>Checking if module PDO is available</td>';
    try {
        $avail = PDO::getAvailableDrivers();
        $page .= '<td><span style="font-size: 1.2em; font-weight: bold;
         background: green">OK</span></td></tr>';
    }
    catch (PDOException $ex) {
        $page .= '<td><span style="font-size: 1.2em; font-weight: bold;
         background: red">NO</span></td></tr>';
        $error = TRUE;
    }
    //$page .= "<tr><td cols=\"2\">".var_export($avail, true)."</td></tr>";
    $page .= "<tr><td>Checking if a suitable PDO driver is available</td>";
    $dbms = NULL;
    foreach ($db_drivers as $driver) {
        $driver = strtolower($driver);
        if (in_array($driver, $avail))
            $dbms .= "<option value=\"$driver\">$driver</option>";
    }
    if ($dbms)
        $page .= '<td><span style="font-size: 1.2em; font-weight: bold;
         background: green">OK</span></td></tr>';
    else {
        $page .= '<td><span style="font-size: 1.2em; font-weight: bold;
         background: red">NO</span></td></tr>';
        $error = TRUE;
    }
    $page .= "<tr><td>Checking if application root is writeable</td>";
    try {
        if (@file_put_contents("$top/config.inc.php", "") === FALSE)
            throw new Exception();
        $page .= '<td><span style="font-size: 1.2em; font-weight: bold;
         background: green">OK</span></td></tr>';
    }
    catch (Exception $ex) {
        $page .= '<td><span style="font-size: 1.2em; font-weight: bold;
         background: red">NO</span></td></tr>';
        $error = TRUE;
    }
    $page .= "<tr><td>Checking if install folder is writeable</td>";
    try {
	$test_file = hash("md5", date("r", time()));
        if (@file_put_contents("$root/$test_file", "") === FALSE)
            throw new Exception();
        if (unlink("$root/$test_file") === FALSE)
            throw new Exception();
        $page .= '<td><span style="font-size: 1.2em; font-weight: bold;
         background: green">OK</span></td></tr>';
    }
    catch (Exception $ex) {
        $page .= '<td><span style="font-size: 1.2em; font-weight: bold;
         background: red">NO</span></td></tr>';
        $error = TRUE;
    }
    $page .= '</table><br/><br/>';

    if (! $error) {
        $page .= <<<__FORM
        <form action="{$_SERVER['PHP_SELF']}" method="post">
            <table class="config">
                <tr>
                    <td class="config">
                        Choose Database system
                    </td>
                    <td class="config">
                        <select name="driver">
                            $dbms
                        </select>
                    </td>
                </tr>
                <tr>
                    <td class="config" colspan="2" style="text-align: center">
                        <input type="hidden" name="stage" value="1"/>
                        <input type="submit" name="action" value=">> Next"/>
                    </td>
                </tr>
            </table>
        </form>
__FORM;
    }
    else {
		remove_config();
        $page .= '<p style="text-align: center">Install missing modules or correct
        errors  marked by
        <span style="font-size: 1.2em; font-weight: bold;background: red">NO</span> to
        continue installation</p>';
    }
}

print $head;

echo "<div id=\"ui\">$page</div>";

print $foot;
?>
