<?php
/* $Id: helper.php 144 2011-03-19 10:59:02Z mir $ */
include_once 'config.inc.php';
require_once 'persistens.php';

define('MICRO', 0);
define('MINOR', 8);
define('MAJOR', 0);

$VERSION = MAJOR.".".MINOR.".".MICRO;
$CURRENT_VERSION = $VERSION;
$PREFIX = TOP_FOLDER."/install/".DBDRIVER;
$PATCH_SET = array(
    "173" => "db_upgrade_0_7_3.sql",
    "174" => "db_upgrade_0_7_4.sql",
    "175" => "db_upgrade_0_7_5.sql",
    "180" => "db_upgrade_0_8_0.sql",
);

$pwd = WEB_ROOT;
if ($pwd[strlen($pwd)-1] == '/')
    $pwd = substr($pwd, 0, -1);

function string2int($str) {
    if (is_numeric($str))
        return $str;
    if (is_string($str)) {
        $parts = explode(".", $str);
        $str = 0;
        for ($i = 0; $i < count($parts); $i++) {
            $num = ($i == 0) ? $parts[$i] + 1 : $parts[$i];
            $str += (pow(10, count($parts) - $i - 1) * $num);
        }
    }
    return $str;
}

function getServerUrl($root = WEB_ROOT, $cwd = "") {
    $root = (! empty($root) && $root[0] == '/') ? substr($root, 1) : $root;
    $root = (! empty($root) && $root[strlen($root) - 1] == '/') ? substr($root, 0, -1) : $root;
    $cwd = (! empty($cwd) && $cwd[0] == '/') ? substr($cwd, 1) : $cwd;
    $cwd = (! empty($cwd) && $cwd[strlen($cwd) - 1] == '/') ? substr($cwd, 0, -1) : $cwd;
    
    //echo var_export($_SERVER, true);
    $protocol = ((isset($_SERVER['HTTPS']) && ! empty($_SERVER['HTTPS'])) || (isset($_SERVER['HTTPS']) && strcasecmp("on", $_SERVER['HTTPS']) === 0)
        || (isset($_SERVER['HTTP_SCHEME']) && strcasecmp("https", $_SERVER['HTTP_SCHEME']) === 0)) ? "https" : "http";
    //echo "$protocol<br/>";
    $server = ($_SERVER['SERVER_PORT'] == 80 || $_SERVER['SERVER_PORT'] == 443)?
        $_SERVER['SERVER_NAME'] : $_SERVER['SERVER_NAME'].':'.$_SERVER['SERVER_PORT'];
    $url = (! empty($cwd)) ? "$protocol://$server/$cwd" : "$protocol://$server";
        
    return "$url/$root";
}

function getServerUri() {
    return TOP_FOLDER;
}

function createKey($key) {
    $td = mcrypt_module_open('rijndael-256', '', 'ofb', '');
    $public = mcrypt_create_iv(mcrypt_enc_get_iv_size($td), MCRYPT_DEV_RANDOM);
    $ks = mcrypt_enc_get_key_size($td);
    mcrypt_module_close($td);

    /* Create key */
    $secret = substr($key, 0, $ks);
    return array($secret, $public);
}

function encode($text) {
    /* Intialize encryption */
    $td = mcrypt_module_open('rijndael-256', '', 'ofb', '');
    $iv = $_SESSION['authenticate']->getPublicKey();
    $key = $_SESSION['authenticate']->getSecretKey();

    mcrypt_generic_init($td, $key, $iv);

    /* Encrypt data */
    $ciffer = mcrypt_generic($td, $text);
    $encrypted = quoted_printable_encode($ciffer);

    /* Terminate encryption handler */
    mcrypt_generic_deinit($td);
    mcrypt_module_close($td);

    return $encrypted;
}

function decode($text) {
    $td = mcrypt_module_open('rijndael-256', '', 'ofb', '');
    $iv = $_SESSION['authenticate']->getPublicKey();
    $key = $_SESSION['authenticate']->getSecretKey();

    /* Initialize encryption module for decryption */
    mcrypt_generic_init($td, $key, $iv);

    /* Decrypt encrypted string */
    $ciffer = quoted_printable_decode($text);
    $decrypted = mdecrypt_generic($td, $ciffer);

    /* Terminate decryption handle and close module */
    mcrypt_generic_deinit($td);
    mcrypt_module_close($td);

    return $decrypted;
}

function implode_cal($text) {
    $infos = explode("\n", $text);
    foreach ($infos as $info) {
        $row = explode('=', $info);
        $result[$row[0]] = $row[1];
    }
    return $result;
}


// taken from PHP documentation comments
function webcal_quoted_printable_encode($input, $line_max = 76) {
	$hex = array('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');
	$lines = preg_split("/(?:\r\n|\r|\n)/", $input);
	$eol = "\r\n";
    $linebreak = '=0D=0A';
    $escape = '=';
    $output = '';

    for ($j=0; $j<count($lines); $j++) {
        $line = $lines[$j];
        $linlen = strlen($line);
        $newline = '';
        for($i = 0; $i < $linlen; $i++) {
            $c = substr($line, $i, 1);
            $dec = ord($c);
            if (($dec == 32) && ($i == ($linlen - 1))) {
				// convert space at eol only
                $c = '=20';
            }
            elseif (($dec == 61) || ($dec < 32 ) || ($dec > 126)) {
				// always encode "\t", which is *not* required
                $h2 = floor($dec/16);
                $h1 = floor($dec%16);
                $c = $escape.$hex["$h2"] . $hex["$h1"];
            }
            if ((strlen($newline) + strlen($c)) >= $line_max) {
				// CRLF is not counted
                $output .= $newline.$escape.$eol;
                // soft line break; " =\r\n" is okay
                $newline = "    ";
            }
            $newline .= $c;
        }
        // end of for
        $output .= $newline;
        if ($j < count($lines) - 1) {
            $output .= $linebreak;
        }
    }
    return trim($output);
}

function newUpdates() {
    global $VERSION, $CURRENT_VERSION;
    
    $con = Persistens::getInstance(DBDRIVER);
    try {
        $res = $con->getVersion();
    }
    catch (Exception $e) {
        ReportError($e);
    }
    $version = $res['version'];
    $version = string2int($version);
    if (! is_numeric($version)) {
        ReportError("Invalid version format");
        exit;
    }
    $CURRENT_VERSION = $version;
    //file_put_contents('/tmp/updates', string2int($VERSION)." > $version", FILE_APPEND);
    return string2int($VERSION) > $version;
}

function upgrade() {
    global $VERSION, $PATCH_SET, $CURRENT_VERSION, $PREFIX;
	$table = 'backup';
	
    $version = string2int($CURRENT_VERSION);
    $con = Persistens::getInstance(DBDRIVER);
    try {
        $res = $con->getVersion();
    }
    catch (Exception $e) {
        ReportError($e);
        exit;
    }
    if (($num = $con->nextTableNumber('backup')) > 0)
    	$table .= $num;

    if ($version < 173) {
		if (($res = $con->execute(
			"create table $table as select * from calendar")) !== true) {
			ReportError($res);
			exit;
		}
		$rows = $con->getCalendarConfig();
		if (! is_array($rows)) {
			ReportError($rows);
			exit;
		}
		foreach($rows as $row) {
			if (function_exists(quoted_printable_encode))
				$ciffer = quoted_printable_encode($row['config']);
			else
				$ciffer = webcal_quoted_printable_encode($row['config']);
            if (($res = $con->execute("begin transaction")) !== true) {
                ReportError($res);
                exit;
			}
			if (($res = $con->execute(
				"update calendar set config = '$ciffer' where id = " .
				$row['id'])) !== true) {
				$con->execute("rollback");
				ReportError($res."<br/>A backup of your calendar data can be found in table backup");
				exit;
			}
		}
		$con->execute("commit");
	}
    if ($version >= 174) {
        // remove pgsql.php from root. Accidentally placed there in release 0.7.4
        if (file_exists(TOP_FOLDER."/pgsql.php"))
            unlink(TOP_FOLDER."/pgsql.php");
	// patch config.inc.php
	if (substr(PHP_OS, 0, 3) !== 'WIN') {
	    $oldcwd = getcwd();
            $cwd = TOP_FOLDER.'/install';
            chdir($cwd);
	    exec("patch -p0 < config.inc.php.patch");
	    chdir($oldcwd);
	}
    }
    foreach ($PATCH_SET as $set => $file) {
        $content = array();
        //echo "$set -> $file<br/>";
        if ($version < $set) {
            //echo $PREFIX."_".$file."<br/>";
            if (! file_exists($PREFIX."_".$file))
                continue;
            $sql = file_get_contents($PREFIX."_".$file);
            $raw_lines = explode("\n", $sql);
            foreach ($raw_lines as $line) {
                if (preg_match("/^--/", $line))
                    continue;
                $content[] = $line;
            }
            $lines = explode(";", join("\n", $content));
            if (count($lines) > 0) {       
                if (($res = $con->execute("begin transaction")) !== true) {
                    ReportError($res);
                    exit;
				}
                foreach ($lines as $line) {
                    $line = trim($line);
                    if (preg_match("/^\s*$/", $line) || preg_match("/^--/", $line))
                        continue;
                    if (($res = $con->execute($line)) !== true) {
                        ReportError($res);
                        $con->execute("rollback");
                        exit;
                    }
                }
                $con->execute("commit");
            }
        }
        else
            continue;
    }
}

function ReportError($msg) {
    // be sure that the supplied parameter is a string and not empty
    if (empty ($msg) || !is_string ($msg)) {
        throw new ErrorException ('Invalid parameter supplied to ReportError', 0, E_ERROR);
    }

    // retrieve error settings
    $display    = strtolower(ini_get('display_errors'));
    $log        = strtolower(ini_get('log_errors'));

    // check if we're displaying errors
    if ($display === 'on' || $display === '1' || $display === 1 || $display === 'true' || $display === true) {
        echo $msg;
    }
    else {
        $pwd = WEB_ROOT;
        if ($pwd[strlen($pwd)-1] == '/')
            $pwd = substr($pwd, 0, -1);
        print '<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
            <head>
                <title>Web Calendar</title>
                <link rel="stylesheet" type="text/css"
                    href="'.$pwd.'/css/top_level.css" />
                <link rel="shortcut icon"
                    href="'.$pwd.'/pixmaps/favicon.ico" />
            </head>
            <body>
                <div id="error_msg">
                    <p>
                        The application has triggered an error which is not
                        recoverable. The execution has therefore been cancelled.
                        <br/><br/>
                        The error is logged and the webmaster will handle
                        the error in due time.
                        <br/><br/>
                        To help fix the application you are welcome to notify
                        the <a href="mailto:'.$_SERVER['SERVER_ADMIN'].'
                        ?subject='.TITLE.': error report['.
                        $_SERVER['SERVER_NAME'].']">webmaster</a>
                        by email with a detailed description containing the
                        following information:
                        <br/><br/>
                        1) What did you do just before this message occurred<br/>
                        2) What did you expect to happen<br/>
                        3) Your browser name and version number.<br/>
                    </p>
                </div>
            </body>
</html>';
    }

    // check if we're logging errors
    if ($log === 'on' || $log === '1' || $log === 1 || $log === 'true' || $log === true) {
        $result = error_log ($msg);

        // check for error while logging
        if (!$result) {
            throw new ErrorException ('Attempt to write message to error log failed in ReportError', 0, E_ERROR);
        }
    }
}

function create_user_data($uid, $pwd, $role) {
    $data = array();
    
    $data['uid'] = $uid;
    $data['pwd'] = sha1($pwd);
    $data['userrole'] = $role;
    $keys = createKey(sha1("{$data['uid']}{$data['pwd']}"));
    $data['seckey'] = $keys[0];
    $data['pubkey'] = $keys[1];
    $data['timezone'] = TIMEZONE;
    $data['view'] = VIEW_STYLE;
    $data['timeout'] = TIMEOUT;
    $data['week_start'] = WEEK_START_SUNDAY;
    $data['start'] = START_HOUR;
    $data['end'] = END_HOUR;
    
    return $data;
}

function popup_window($text = '', $redirect = NULL, $form_elem = array(), $title = NULL) {
    $con = Persistens::getInstance(DBDRIVER);
    if (! is_array($res = $con->getVersion())) {
        ErrorReport($res);
    }
    
    $title = ($title) ? $title : TITLE;
    /* deprecated */
    if (count($form_elem) < 1) {
        $form = NULL;
        $input = NULL;
    }
    else {
        $form = key($form_elem);
        $input = $form_elem[$form];
    }
    /* end deprecated */
    $referer = ($redirect) ? urldecode($redirect) : WEB_ROOT;
    //print "$referer<br/>";
    //exit;
    $pwd = WEB_ROOT;
$head = <<<__HEAD
<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<title>$title</title>
<meta http-equiv="content-type" content="application/xhtml+xml; charset=UTF-8"/>
<meta http-equiv="content-style-type" content="text/css"/>
<link rel="stylesheet" type="text/css" href="$pwd/css/top_level.css" />
<link rel="shortcut icon" href="$pwd/pixmaps/favicon.ico" />
<style type="text/css">
<!--
#display_overlay_holder {
	width: 100%;
	height: 100%;
	position: absolute;
	top: 0px;
	left: 0px;
	display:none;
}
#display_overlay_bg {
	position: absolute;
	left: 0px;
	top: 0px;
	width: 100%;
	height: 100%;
	background-color:#000000;
	opacity: 0.55;
	filter: alpha(opacity=85);
}
#display_horizon {
	position: absolute;
	top: 45%;
	left: 0px;
	width: 100%;
	height: 1px;
	overflow: visible;
}
#display_content {
	position: absolute;
	width: 400px;
	height: 250px;
	left: 50%;
	margin-left: -200px;
	top: -125px;
	background-color: #CCCCCC;
}
#text_content {
    font-size: 0.8em;
    color: blue;
}
-->
</style>
<script type="text/javascript" src="$pwd/js/helper.js"></script>
</head>
<body onload="show_the_overlay()">
<table style="width: 100%;">
<tr>
<td style="width: 33%"><img src="$pwd/pixmaps/calendar.png" alt="calendar.png" /></td>
<td style="width: 33%; text-align: center;"><a href="$pwd/logout.php"><img style="border: 0" src="$pwd/pixmaps/exit.png" width="32" height="32" alt="Logout" /><br/>Logout</a></td>
<td style="text-align: right"><span style="font-size: 1.6em">DAViCal Web Calendar</span><br/> - A Web Interface for <a href="javascript: newwin('http://www.davical.org/');">DAViCal</a></td>
</tr>
</table>
__HEAD;
$display = <<<_DISPLAY
<div id="display_overlay_holder">
	<div id="display_overlay_bg" />
	<div id="display_horizon">
		<div id="display_content">
        <div id="text_content">
		$text
        <br/><br/><br/>
        <p style="text-align: center;">
        <button type="button" onclick="hide_the_overlay('$referer')">Cancel</button>
        </p>
        </div>
		</div>
	</div>
</div>
_DISPLAY;
$foot = <<<_FOOTER
<div id="footer">
<p>
    $title {$res[0]} - &copy; 2010, 2011 Michael Rasmussen<br/>Released under GPLv3
    <a href="http://validator.w3.org/check?uri=referer">
        <img src="http://www.w3.org/Icons/valid-xhtml10-blue.png"
        alt="Valid XHTML 1.0 Strict" height="31" width="88" />
    </a>
    <a href="http://jigsaw.w3.org/css-validator/check/referer">
        <img src="http://www.w3.org/Icons/valid-css2-blue.png"
        alt="Valid CSS 2.0" height="31" width="88" />
    </a>
</p>
</div>
_FOOTER;
    ob_start();
    print $head;
	include TOP_FOLDER.'/include/menu.inc.php';
	print "<div id=\"ui\">&nbsp;</div>";
    print $foot;
    print $display;
    print "</body></html>";
    
    return ob_get_clean();
}

function construct_URL($query_string, $attributes = array()) {
    $test = trim($query_string);
    if (empty($test))
        return array();
    $current = NULL;
    $query_str = urldecode($query_string);
    //print "$query_str<br/>";
    $q = explode('&', $query_str);
    //print_r($q); echo "<br/>";
    foreach ($q as $elem) {
        $s = explode('=', $elem);
        //print_r($s); echo "<br/>";
        if (! $current && in_array($s[0], $attributes)) {
            if (count($s) > 2) {
                $key = array_shift($s);
                $value = array_shift($s);
                $value .= '=';
                //print "kv: $key $value<br/>";
                while ($s) {
                    $value .= array_shift($s);
                    $value .= '&';
                    $value .= array_shift($s);
                }
                $current = $key;
            }
            else {
                $key = array_shift($s);
                $value = array_shift($s);
            }
            $query[$key] = $value;
            //print_r($query); echo "<br/>";
        }
        else if ($current) {
            $value = $query[$current];
            while ($s) {
                $value .= array_shift($s);
                $value .= '=';
                $value .= array_shift($s);
            }
            $query[$current] = $value;
            $current = NULL;
            //print_r($query); echo "<br/>";
        }
        else {
            $key = array_shift($s);
            $value = array_shift($s);
            $query[$key] = $value;
            //print_r($query); echo "<br/>";
        }
    }
    //print_r($query); echo "<br/>";
    //exit;
    // urlencode if nessasary
    foreach ($query as $key => $value) {
        if (strpos($value, '&') !== FALSE)
            $value = urlencode($value);
        $query_array[$key] = $value;
    }
    return $query_array;
}

//Begin main function definition
function ErrorsAsExceptions($level, $msg, $fileName, $lineNumber) {
    // do nothing if error reporting is turned off
    if (error_reporting() === 0) {
        return;
    }

    // be sure received error is supposed to be reported
    if (error_reporting() & $level) {
        try {
            // report error to appropriate channels
            ReportError(/*$reportMsg*/$msg);
        }
        catch (ErrorException $e) {
            // ignore errors while reporting
        }

        // go ahead and throw the exception
        throw new ErrorException($msg, 0, $level, $fileName, $lineNumber);
    }
}

set_error_handler('ErrorsAsExceptions');

?>
